searchNodes=[{"ref":"Arbor.Tree.html","title":"Arbor.Tree","type":"module","doc":"Using Arbor.Tree will add common tree traversal functions to your Ecto model. Examples defmodule Comment do use Ecto.Schema use Arbor.Tree, table_name: &quot;comments&quot;, tree_name: &quot;comments_tree&quot;, primary_key: :id, primary_key_type: :id, foreign_key: :parent_id, foreign_key_type: :id orphan_strategy: :nothing schema &quot;comments&quot; do field :body, :string belongs_to :parent, Arbor.Comment timestamps() end end"},{"ref":"readme.html","title":"Arbor","type":"extras","doc":"Arbor Ecto adjacency list and tree traversal using CTEs. Arbor uses a parent_id field and CTEs to create simple deep tree-like SQL hierarchies."},{"ref":"readme.html#installation","title":"Arbor - Installation","type":"extras","doc":"If available in Hex, the package can be installed as: Add arbor to your list of dependencies in mix.exs: For Ecto SQL 3+: def deps do [{:arbor, &quot;~&gt; 1.1.0&quot;}] end For Ecto 2: def deps do [{:arbor, &quot;~&gt; 1.0.6&quot;}] end"},{"ref":"readme.html#benchmarks","title":"Arbor - Benchmarks","type":"extras","doc":"Arbor has been benchmarked on 10mm+ record tables with efficient results: 10,000,000 rows, 25% root Running siblings 10000 runs Total time: 1.793026000000013 Avg: 1.7930260000000131e-4 Running children 10000 runs Total time: 1.5967949999999786 Avg: 1.5967949999999787e-4 Running descendants 10000 runs Total time: 2.5418830000000012 Avg: 2.5418830000000013e-4 Running ancestors 10000 runs Total time: 2.87076499999998 Avg: 2.87076499999998e-4"},{"ref":"readme.html#usage","title":"Arbor - Usage","type":"extras","doc":"defmodule Comment do use Ecto.Schema # See config options below use Arbor.Tree, foreign_key_type: :binary_id schema &quot;comments&quot; do field :body, :string    belongs_to :parent, __MODULE__ timestamps end end All methods return composable Ecto queries. For in depth examples see the tests Roots Returns root level records. roots = Comment.roots |&gt; Repo.all Siblings Return the siblings of a record. siblings = my_comment |&gt; Comment.siblings |&gt; Comment.order_by_popularity |&gt; Repo.all ancestors Returns the entire ancestor (parent&#39;s parent&#39;s parent, etc) path to the record, but not including the record. ancestors = my_comment |&gt; Comment.ancestors |&gt; Comment.order_by_inserted_at |&gt; Repo.all Descendants Returns the entire descendant tree of a record, but not including the record. descendants = my_comment |&gt; Comment.descendants |&gt; Comment.order_by_inserted_at |&gt; Repo.all A second parameter can be passed to descendants to specify how deep from the root of the tree to retrieve the descendants from. descendants = my_comment |&gt; Comment.descendants(2) |&gt; Comment.order_by_inserted_at |&gt; Repo.all Children Returns the immediate children of a record. children = my_comment |&gt; Comment.children |&gt; Repo.all Parent Returns the record&#39;s parent. parent = my_comment |&gt; Comment.parent |&gt; Repo.first"},{"ref":"readme.html#options","title":"Arbor - Options","type":"extras","doc":"table_name - set the table name to use in CTEs tree_name - set the name of the CTE primary_key - defaults to field from Ecto&#39;s @primary_key primary_key_type - defaults to type from Ecto&#39;s @primary_key foreign_key - defauts to :parent_id foreign_key_type - defaults to type from Ecto&#39;s @primary_key orphan_strategy - defaults to :nothing currently unimplemented"},{"ref":"readme.html#contributing","title":"Arbor - Contributing","type":"extras","doc":"You&#39;ll need PostgreSQL installed and a user that can create and drop databases. There is a docker-compose file for your convienence. You can specify it with the environment variable ARBOR_DB_USER. The mix test task will drop and create the database for each run. docker-compose up -d ARBOR_DB_USER=postgres mix test docker-compose down"}]